#include <stdio.h>
#include <stdlib.h>

void greska(const char *msg);

int **alociraj_matricu(int n, int m);

void oslobodi_matricu(int **A, int n);

void ucitaj_matricu(int **A, int n, int m);

void ispisi_matricu(int **A, int n, int m);

int main(int argc, char const *argv[])
{
    int n, m, k, tmp;
    int **A, **B, **C;
    printf("Unesite dimenzije matrice A: ");
    scanf("%d%d", &n, &m);
    printf("Unesite dimenzije matrice B: ");
    scanf("%d%d", &tmp, &k);

    if (tmp != m)
    {
        greska("Broj kolona prve matrice se mora poklapati sa brojem vrsta druge!");
    }

    A = alociraj_matricu(n, m);
    B = alociraj_matricu(m, k);
    C = alociraj_matricu(n, k);

    printf("Unesite matricu A:\n");
    ucitaj_matricu(A, n, m);
    printf("Unesite matricu B:\n");
    ucitaj_matricu(B, m, k);

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < k; j++)
        {
            // int suma = 0;
            // for (int p = 0; p < m; p++)
            // {
            //     suma += A[i][p] * B[p][j];
            // }
            // C[i][j] = suma;
            __asm__(
                "mov %[suma], 0 \n\t"
                "xor rcx, rcx \n\t"
                "for_loop: \n\t"
                "cmp ecx, %[m] \n\t"
                "je for_loop_end \n\t"
                "mov r8, [%[A] + 8*%[i]] \n\t" // r8 - A[i]
                "mov r9, [%[B] + 8*rcx] \n\t"  // r9 - B[p]
                "mov eax, [r8 + 4*rcx] \n\t"
                "mov r10d, [r9 + 4*%[j]] \n\t"
                "imul r10d \n\t"
                "add %[suma], eax \n\t"
                "inc rcx \n\t"
                "jmp for_loop \n\t"
                "for_loop_end: \n\t"
                : [suma] "=&r"(C[i][j])
                : [A] "r"(A), [B] "r"(B), [i] "r"((long)i), [j] "r"((long)j),
                  [m] "r"(m)
                : "r8", "r9", "r10", "eax", "edx", "rcx");
        }
    }
    printf("Rezultat mnozenja A*B:\n");
    ispisi_matricu(C, n, k);

    oslobodi_matricu(A, n);
    oslobodi_matricu(B, m);
    oslobodi_matricu(C, n);

    return 0;
}

void greska(const char *msg)
{
    fprintf(stderr, "Greska: %s\n", msg);
    exit(EXIT_FAILURE);
}

int **alociraj_matricu(int n, int m)
{
    int **A = malloc(n * sizeof(int *));
    if (A == NULL)
        greska("Neuspela alokacija memoorije!");

    for (int i = 0; i < n; i++)
    {
        A[i] = malloc(m * sizeof(int));
        if (A[i] == NULL)
        {
            for (int j = 0; j < i; j++)
            {
                free(A[i]);
            }
            greska("Neuspela alokacija memorije!");
        }
    }

    return A;
}
void oslobodi_matricu(int **A, int n)
{
    for (int i = 0; i < n; i++)
    {
        free(A[i]);
    }
    free(A);
}

void ucitaj_matricu(int **A, int n, int m)
{
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            scanf("%d", &A[i][j]);
        }
    }
}

void ispisi_matricu(int **A, int n, int m)
{
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            printf("%d ", A[i][j]);
        }
        printf("\n");
    }
}