#include <stdio.h>
#include <stdlib.h>

void greska(const char *msg);

void merge_sort(int *a, int *buff, int l, int d)
{
    if (l >= d)
        return;
    int s = (l + d) / 2;
    merge_sort(a, buff, l, s);
    merge_sort(a, buff, s + 1, d);

    // int levo_i = l;
    // int desno_i = s + 1;
    // int i = l;
    // for (; levo_i <= s && desno_i <= d; i++)
    // {
    //     if (a[levo_i] < a[desno_i])
    //     {
    //         buff[i] = a[levo_i];
    //         levo_i++;
    //     }
    //     else
    //     {
    //         buff[i] = a[desno_i];
    //         desno_i++;
    //     }
    // }
    // for (; levo_i <= s; levo_i++, i++)
    // {
    //     buff[i] = a[levo_i];
    // }
    // for (; desno_i <= d; desno_i++, i++)
    // {
    //     buff[i] = a[desno_i];
    // }

    __asm__(
        "for_loop_merge: \n\t"
        "cmp %[levo_i], %[s] \n\t"
        "jg for_loop_merge_end \n\t"
        "cmp %[desno_i], %[d] \n\t"
        "jg for_loop_merge_end \n\t"
        "mov r8d, [%[a] + 4*%[levo_i]] \n\t"  // r8d - a[levo_i]
        "mov r9d, [%[a] + 4*%[desno_i]] \n\t" // r8d - a[desno_i]
        "cmp r8d, r9d \n\t"
        "jge levi_veci \n\t"
        "mov [%[buff]+4*%[i]], r8d \n\t"
        "inc %[levo_i] \n\t"
        "jmp nastavak \n\t"
        "levi_veci: \n\t"
        "mov [%[buff]+4*%[i]], r9d \n\t"
        "inc %[desno_i] \n\t"
        "nastavak: \n\t"
        "inc %[i] \n\t"
        "jmp for_loop_merge \n\t"
        "for_loop_merge_end: \n\t"

        "for_loop_levi: \n\t"
        "cmp %[levo_i], %[s] \n\t"
        "jg for_loop_levi_end \n\t"
        "mov r8d, [%[a] + 4*%[levo_i]] \n\t" // r8d - a[levo_i]
        "mov [%[buff] + 4*%[i]], r8d\n\t"
        "inc %[levo_i] \n\t"
        "inc %[i] \n\t"
        "jmp for_loop_levi \n\t"
        "for_loop_levi_end: \n\t"

        "for_loop_desni: \n\t"
        "cmp %[desno_i], %[d] \n\t"
        "jg for_loop_desni_end \n\t"
        "mov r8d, [%[a] + 4*%[desno_i]] \n\t" // r8d - a[desno_i]
        "mov [%[buff] + 4*%[i]], r8d\n\t"
        "inc %[desno_i] \n\t"
        "inc %[i] \n\t"
        "jmp for_loop_desni \n\t"
        "for_loop_desni_end: \n\t"
        :
        : [levo_i] "r"((long)l), [desno_i] "r"((long)s + 1), [i] "r"((long)l),
          [a] "r"(a), [s] "r"((long)s), [d] "r"((long)d), [buff] "r"(buff)
        : "r8", "r9");

    for (int i = l; i <= d; i++)
    {
        a[i] = buff[i];
    }
}

void sort(int *a, int n)
{
    int *buff = malloc(n * sizeof(int));
    if (buff == NULL)
        greska("Neuspesna alokacija memorije!");

    merge_sort(a, buff, 0, n - 1);
    free(buff);
}

int main(int argc, char const *argv[])
{
    int n;
    int *a;
    scanf("%d", &n);
    if (n <= 0)
        greska("n mora biti vece od nule!");
    a = malloc(n * sizeof(int));
    if (a == NULL)
        greska("Neupsesna alokacija memorije!");
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &a[i]);
    }

    sort(a, n);

    for (int i = 0; i < n; i++)
    {
        printf("%d ", a[i]);
    }
    free(a);

    return 0;
}

void greska(const char *msg)
{
    fprintf(stderr, "Greska: %s\n", msg);
    exit(EXIT_FAILURE);
}